# Reproted problems

## NixOS fails to upgrade
We have to deploy our own channel with verified builds.

## Volumes are not used properly
We need a controller which will detect them, format them, expand them and also move apps between them. Probably app should use Hetzner API to expand volume automatically.

## Server control is lost when losing app's storage
Solution implemented on API side as recovery tokens in [[changelog#authorization_tokens branch|1.2.0]]. We need to implement this on app side.

## Ability to change user passwords
Has to be implemented on both server and app side.

## Server restoration from backup
There are several problems

### We don't backup current userdata from nixos-config
So settings and users are not restored.
### App don't check for the current users list
But we already have an endpoint for that.
### Services are not stopped during restoration
Leads to files corruption?
### User is not notified that they may have to add a credit card to b2
Free limits are pretty small and restoration may easily spend them all, and after that, everything is broken.

## Disk storage is not monitored
Which leads to big problems for the server. API has to control available space, and how each app uses it. App should alert user and give options on storage management.


# Backlog

##  No check for invalid DNSSEC setup
If DNSSEC is set up incorrectly, app won't tell user why server can't be set up.

## Email can only use [a-z]
Some users wanted emails in format name.surname@domain.tld, but couldn't. As we create unix users, we have to use `r"^[a-z_][a-z0-9_]+$"`. User documentation needs explanations on this?

## Problems with international domains
I can't determine the scope of the problems it causes, without having one. But it surely creates a lot of problems on many stages, starting at server creation.
Should we buy an international domain?

## VPN
Still looking for another protocol.

## HTTP headers on nextcloud are not optimal
X-Content-Type-Options is not set to "nosniff" and X-Frame-Options not set to "SAMEORIGIN".

## Need more info and logs on... everything?
Especially on server creation. If we could display real-time logs of server setup, it would be perfect.

## Free TLDs don't work
Reported as [#84](https://git.selfprivacy.org/kherel/selfprivacy.org.app/issues/84). 

## Servers are only deployed in Germany
Probably we should allow choosing the datacenter for the server. Also, in the future, provide more service providers.

## ACME sometimes fails
We should at least start by exposing logs.

## Some users want an in-depth video
I think we should make it after we handle major features of our upcoming release.

